import classes.Vector;
import classes.Loader;
import mx.transitions.OnEnterFrameBeacon;

class classes.Model {
	var position:Vector;
	var color:Number;
	var health:Number;
	var frames:Array;
	var maxFrames:Number;
	var edges:Array;
	var frame:Number;
	var thickness:Number;
	var depth:Number;
	var _visible:Boolean;
	var localTime:Number, frequency:Number;
	function Model(x:Number, y:Number, z:Number, nColor:Number, nThickness:Number, nHealth:Number, nFrame:Number)	{
		position = new Vector(0.0,0.0,0.0);
		position.x = x;
		position.y = y;
		position.z = z;
		frame = nFrame;
		color = nColor;
		thickness = nThickness;	
		health = nHealth;		
		frames = new Array();
		edges =	new Array();
		localTime = 0;
		frequency = 10; 
		_visible = true;
		OnEnterFrameBeacon.init();
	}
	function load3DMesh(meshName:String):Void{
		Loader.load("models/"+meshName, this);
	}
	function nextFrame():Void{
		if (frame>maxFrames-2) frame = 0;
		frame++;
	}
	function onEnterFrame():Void{
		if (localTime == frequency) {
			this.nextFrame();
			localTime = 0;
		} else {
			localTime++;
		}
	}
	function _nextFrame():Number{
		var f:Number = frame;
		if (f>maxFrames-2) f = 0;
		f++;
		return f;
	}	
	
	function setPosition(dx:Number, dy:Number, dz:Number):Void{
		position.x = dx;
		position.y = dy;
		position.z = dz;
		
	}	
	
	function play():Void{
		MovieClip.addListener(this);
	}
	function stop():Void{
		MovieClip.removeListener(this);
	}
}