﻿import classes.*;
class classes.Scene3D {
	var height:Number,width:Number;
	var collisionMap:Number;
	var objList: Array;
	var gameCam: Camera3D;
	var basisa:Vector;
	var basisb:Vector;
	var basisc:Vector;
	function Scene3D(nWidth:Number,nHeight:Number){
		width = nWidth/2;
		height = nHeight/2;
		basisa = new Vector();
		basisb = new Vector();
		basisc = new Vector();
		gameCam = new Camera3D(0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 450);
		objList = new Array();
	}
	function updateMatrix():Void{
		gameCam.loadParameters(collisionMap);
		basisc = gameCam.target.returnSubtraction(gameCam.location).normalize();
		basisa = gameCam.uppend.crossProduct(basisc).normalize();
		basisb = basisc.crossProduct(basisa);
	    gameCam.finalMatrix.$m[0][0] = basisa.x; 	gameCam.finalMatrix.$m[1][0] = basisb.x;   gameCam.finalMatrix.$m[2][0] = basisc.x;
		gameCam.finalMatrix.$m[0][1] = basisa.y; 	gameCam.finalMatrix.$m[1][1] = basisb.y;   gameCam.finalMatrix.$m[2][1] = basisc.y;
		gameCam.finalMatrix.$m[0][2] = basisa.z; 	gameCam.finalMatrix.$m[1][2] = basisb.z;   gameCam.finalMatrix.$m[2][2] = basisc.z;
	}
	
	static function interpolate(V1:Vector, V2:Vector, t:Number):Vector{
		return new Vector(V1.x + (V2.x-V1.x)*t, V1.y + (V2.y-V1.y)*t, V1.z + (V2.z-V1.z)*t);
	}
	
	function project2D():Void{
	var perspectiveRatio:Number;
	var t:Vector;
		depthSort();
		for (var i=0; i<objList.length; i++) {
			for (var j=0; j<objList[i].frames[objList[i].frame].length; j++) {
				t = interpolate(objList[i].frames[objList[i].frame][j], objList[i].frames[objList[i]._nextFrame()][j], objList[i].localTime/objList[i].frequency);
				t.x += objList[i].position.x
				t.y += objList[i].position.y
				t.z += objList[i].position.z
				t = t.returnSubtraction(gameCam.location);
				gameCam.finalMatrix.transformVector(t);
				t.z -= gameCam.FOV;
				if (t.z <= -400) objList[i]._visible = false; else objList[i]._visible = true;
				perspectiveRatio = 1.0/(t.z/gameCam.FOV+1.0);
				objList[i].frames[objList[i].frame][j].rx = width + t.x*perspectiveRatio;
				objList[i].frames[objList[i].frame][j].ry = height - t.y*perspectiveRatio;
			}
		}
		
	}
	function render():Void{
		_root.clear();
		for (var i=0; i<=objList.length; i++) {
			if (objList[i]._visible) {
				_root.lineStyle(objList[i].thickness*1000/objList[i].depth, objList[i].color);
				_root.moveTo(objList[i].frames[objList[i].frame][objList[i].edges[0]].rx, objList[i].frames[objList[i].frame][objList[i].edges[0]].ry);
				for (var j=0; j<objList[i].edges.length; j++) {
					if (objList[i].edges[j] == "&") {
						j++;				
						_root.moveTo(objList[i].frames[objList[i].frame][objList[i].edges[j]].rx, objList[i].frames[objList[i].frame][objList[i].edges[j]].ry);
					} else _root.lineTo(objList[i].frames[objList[i].frame][objList[i].edges[j]].rx, objList[i].frames[objList[i].frame][objList[i].edges[j]].ry);
				}
			}
		}
	}
	function addObject(x:Number,y:Number,z:Number,color:Number, thickness:Number,health:Number,frame:Number,mesh:String):Void	{
		objList[objList.length] = new Model(x, y, z, color, thickness, health, frame);
		objList[objList.length-1].load3DMesh(mesh);
	}	
	
	function collision():Void {
		
	}

	function depthSort():Void {
	var i:Number;
		for (var i=0; i<objList.length; i++) objList[i].depth = objList[i].position.returnSubtraction(gameCam.location).norm()
		objList.sortOn("depth", Array.DESCENDING | Array.NUMERIC);
	}

//	function addObject(obj:Model):Void{
		
//	}
	
	
}
