﻿class classes.Vector {
	var x:Number,y:Number,z:Number;
	var rx:Number,ry:Number;
	function Vector(vx:Number, vy:Number, vz:Number) {
		x = vx;
		y = vy;
		z = vz;
	}
	function resetComponents(vx:Number, vy:Number, vz:Number):Void {
		x = vx;
		y = vy;
		z = vz;
	}	
	function returnSubtraction(V:Vector):Vector	{
		return new Vector(x - V.x, y - V.y, z - V.z);
	}
	function crossProduct (V:Vector):Vector	{
		return new Vector(y*V.z - z*V.y, z*V.x - x*V.z, x*V.y - y*V.x);
	}
	function norm():Number {
		return Math.sqrt((x * x) + (y * y) + (z * z));
	}
	function normalize():Vector	{
		var n:Number = 1.0/this.norm();
		x *= n;
		y *= n;
		z *= n;
		return this;
	}	
	function copy (v:Vector):Void {
		x = v.x;
		y = v.y;
		z = v.z;
	}
	static function translateVector ():Void	{
		arguments[0].x += arguments[1] * arguments[2].x;
		arguments[0].y += arguments[1] * arguments[2].y;
		arguments[0].z += arguments[1] * arguments[2].z;
		return;
	}
	static function rotateVector(arg1:Vector,arg2:Number,arg3:Vector,arg4:Vector) {
		var $s:Number = Math.sin (arg2);
		var $c:Number = Math.cos (arg2);
			var t:Number = 1.0 - $c;
			var t1:Number = arg3.x * t;
			var t2:Number = arg3.y * t;
			var t3:Number = arg3.z * t;
			var sx:Number = $s * arg3.x;
			var sy:Number = $s * arg3.y;
			var sz:Number = $s * arg3.z;
			var tx:Number = arg1.x - arg4.x;
			var ty:Number = arg1.y - arg4.y;
			var tz:Number = arg1.z - arg4.z;
			var xp:Number = arg4.x + tx * (t1 * arg3.x + $c) + ty * (t2 * arg3.x - sz) + tz * (t3 * arg3.x + sy);
			var yp:Number = arg4.y + tx * (t1 * arg3.y + sz) + ty * (t2 * arg3.y + $c) + tz * (t3 * arg3.y - sx);
			var zp:Number = arg4.z + tx * (t1 * arg3.z - sy) + ty * (t2 * arg3.z + sx) + tz * (t3 * arg3.z + $c);
			arg1.x = xp;
			arg1.y = yp;
			arg1.z = zp;
			return;
		}	
}
